#include<iostream>

#define PARAM_ANZ 20
#define PUFFER_GROESSE 300
#define FUNK_ANZ 13

using namespace std;

int dummy_i = -1;
int dummy_k = -1;
int dummy_pwm_antrieb = 0;
int dummy_pwm_servo = 0;
//Um eine bessere bersicht zu erhalten, werden die Methoden der Klasse "Befehle"
//zunchst nur als Prototypen hingeschrieben und erst hinter der Klasse implementiert.
class Befehle
{
  private:
     char skript[PUFFER_GROESSE];                
     int  param[PARAM_ANZ];

     void (Befehle::*zeiger[FUNK_ANZ])(int*,int*,int*);    
                    
     int anzahl_befehle;
     int befehls_zaehler;                    
                         
  public:      
     Befehle()
     {
          zeiger[0] = &Befehle::A_Null;
          zeiger[1] = &Befehle::B_Ink;
          zeiger[2] = &Befehle::C_Dek;
          zeiger[3] = &Befehle::D_Plus;
          zeiger[4] = &Befehle::E_Minus;
          zeiger[5] = &Befehle::F_Mal;
          zeiger[6] = &Befehle::G_Durch;
          zeiger[7] = &Befehle::H_Mod;
          zeiger[8] = &Befehle::I_Array;
          zeiger[9] = &Befehle::J_Antrieb;
          zeiger[10] = &Befehle::K_Servo;
          zeiger[11] = &Befehle::L_Sensor;
          zeiger[12] = &Befehle::M_Om4;
          
//       (Befehle::Befehle::*zeiger[FUNK_ANZ])(int*,int*,int*)
     }               
               
     //Funktionen, die elementare Operationen umsetzen:               
     void A_Null(int* y, int* a, int* b); //y=0
     void B_Ink(int* y, int* a, int* b); //y++
     void C_Dek(int* y, int* a, int* b); //y--
     void D_Plus(int* y, int* a, int* b); //y=a+b
     void E_Minus(int* y, int* a, int* b); //y=a-b
     void F_Mal(int* y, int* a, int* b); //y=a*b
     void G_Durch(int* y, int* a, int* b); //y=a/b
     void H_Mod(int* y, int* a, int* b); //y=a%b
     //Funktion, um Folgen von Arrayelementen verarbeiten zu knnen:
     void I_Array(int* y, int* a, int* b); //arr=Adresse von y,  arr[a]=arr[b]
     //Funktionen, die den Zugriff auf die COACH-Peripherie erlauben:
     void J_Antrieb(int* y, int* a, int* b); //PWM_Antrieb = y (+/-1023)
     void K_Servo(int* y, int* a, int* b); //PWM_Servo = y (+/-36)
     void L_Sensor(int* y, int* a, int* b); //y=Distanz [mm]                                                        
     void M_Om4(int* y, int* a, int* b); //y=omega_viertel (Wert mu durch vier geteilt werden, um Omega zu erhalten.)
                                   
     void uebertrageSkript(char* text)
     {
         int i=0;
         while(text[i]!=';')
         {
             if(i%5==0)                            
                 skript[i] = text[i]-'A';
             else                                             
                 skript[i] = text[i]-'a';
             i++;
         }                   
         anzahl_befehle = i/5;
         befehls_zaehler = 0;                    
     }

     void uebertrageParameter(char* parameter_uebergabe)
     {
        int i=0;
        int k=0;
        char c = parameter_uebergabe[i];
        bool minus=false;
        int hilf=0;
        while(c!=';' && c!='\0' && k<PARAM_ANZ)
        {
            if(c=='-')
            {
                minus=true;                  
                hilf=0;
            }
            else if(c=='+')
            {
                minus=false;                  
                hilf=0;
            }
            else if(c>='0' && c<='9')
            {
                hilf*=10;
                hilf+=c-48;                     
            }                                                     
            else if(c==',')
            {
                if(minus==true)
                    hilf = -hilf;             
                param[k]=hilf;
                k++;             
            }                                                     

            i++;
            c = parameter_uebergabe[i];                                  
        }
    }     
    
    void zeigeParameter()
    {
        cout<<"Parameter:"<<endl;         
        for(int i=0;i<PARAM_ANZ;i++)
            cout<<param[i]<<" ";
        cout<<endl;                     
    }
    
    void bearbeiteNaechstenBefehl()
    {
        if(param[ skript[befehls_zaehler*5+4] ] > 0)
            (this->*(zeiger[skript[befehls_zaehler*5]]))(  &param[skript[befehls_zaehler*5+1]], 
                                                           &param[skript[befehls_zaehler*5+2]], 
                                                           &param[skript[befehls_zaehler*5+3]]  );
        befehls_zaehler++;
        befehls_zaehler%=anzahl_befehle;                                                                             
    }
};

//Funktionen, die elementare Operationen umsetzen:               
void Befehle::A_Null(int* y, int* a, int* b) //y=0
{
    *y=0;     
}
void Befehle::B_Ink(int* y, int* a, int* b) //y++
{
    (*y)++;     
}
void Befehle::C_Dek(int* y, int* a, int* b) //y--
{
    (*y)--;     
}
void Befehle::D_Plus(int* y, int* a, int* b) //y=a+b
{
    *y=*a+*b;
}
void Befehle::E_Minus(int* y, int* a, int* b) //y=a-b
{
    *y=*a-*b;
}
void Befehle::F_Mal(int* y, int* a, int* b) //y=a*b
{
    *y=*a**b;
}
void Befehle::G_Durch(int* y, int* a, int* b) //y=a/b
{
    *y=*a/ *b;
}
void Befehle::H_Mod(int* y, int* a, int* b) //y=a%b
{
    *y=*a%*b;         
}
//Funktion, um Folgen von Arrayelementen verarbeiten zu knnen:
void Befehle::I_Array(int* y, int* a, int* b) //arr=Adresse von y,  arr[a]=arr[b]
{
    a = y + *a;
    b = y + *b;
    
    *a = *b;         
}
//Funktionen, die den Zugriff auf die COACH-Peripherie erlauben:
void Befehle::J_Antrieb(int* y, int* a, int* b) //PWM_Antrieb = y (+/-1023)
{
    dummy_pwm_antrieb = *y;     
    cout<<"pwm_antrieb="<<dummy_pwm_antrieb<<endl;
}
void Befehle::K_Servo(int* y, int* a, int* b) //PWM_Servo = y (+/-36)
{
    dummy_pwm_servo = *y;     
    cout<<"pwm_servo="<<dummy_pwm_servo<<endl;
}
void Befehle::L_Sensor(int* y, int* a, int* b) //y=Distanz [mm]                                                        
{
    int werte[] = {200,100,300,150,155,120,12,0,30,60}; //10 Zufallswerte     
    dummy_i++;
    *y = werte[dummy_i%10];

    cout<<"Sensor liefert Distanz="<<*y<<endl;
}
void Befehle::M_Om4(int* y, int* a, int* b) //y=omega_viertel (Wert mu durch vier geteilt werden, um Omega zu erhalten.)
{
    int werte[] = {4,8,10,15,20,18,15,23,30,29}; //10 Zufallswerte     
    dummy_k++;
    *y = werte[dummy_k%10];         
    
    cout<<"Drehgeber liefert om_viertel="<<*y<<endl;
}


int main()
{    
    Befehle befehle;

    //Zunchst die Funktionen direkt testen:
    int y=1, a=14, b=3;
    befehle.A_Null(&y,&a,&b);
    cout<<"y="<<y<<endl;                   
    befehle.B_Ink(&y,&a,&b);
    cout<<"y="<<y<<endl;                   
    befehle.D_Plus(&y,&a,&b);
    cout<<"y=14+3="<<y<<endl;                   
    befehle.F_Mal(&y,&a,&b);
    cout<<"y=14*3="<<y<<endl;                   
    befehle.H_Mod(&y,&a,&b);
    cout<<"y=14%3="<<y<<endl;                   
    int arr[] = {1,3,0,17,18,19};
    befehle.I_Array(&arr[2],&arr[0],&arr[1]);
    cout<<arr[3]<<endl;
    befehle.C_Dek(&arr[1],&arr[1],&arr[1]);
    befehle.I_Array(&arr[2],&arr[0],&arr[1]);
    cout<<arr[3]<<endl;
    
    //Parameterbertragung testen:
    char parameter[] = {"-2,-1,+0,+1,+2,+3,+4,+5,+6,+7,+11,-11,+12,-12,+13,-13,+14,-14,+15,-15,;"};
    befehle.uebertrageParameter(parameter);
    befehle.zeigeParameter();
    
    //Einfaches Skript bertragen und testen:
    //B_Ink(f) => f=4                
    //D_Plus(a,e,f) => a=2+4=6
    //I_Array(k,d,e) <=> I_Array(param[10],param[3],param[4]) => param[10+1]=param[10+2] => l=12
    //M_Om4(a) Drehgeberwert in a speichern
    //F_Mal(a,a,g) a mit g multiplizieren
    //J_Antrieb(a), a als Antriebswert setzen
    
    char skript[] = {"BfffsDaefsIkdesMaaasFaagsJaaas;"};
    befehle.uebertrageSkript(skript);
    cout<<"Ergebnisse bei einfachem Skriptbeispiel:"<<endl;
    befehle.bearbeiteNaechstenBefehl();
    befehle.zeigeParameter();
    befehle.bearbeiteNaechstenBefehl();
    befehle.zeigeParameter();
    befehle.bearbeiteNaechstenBefehl();
    befehle.zeigeParameter();
    befehle.bearbeiteNaechstenBefehl();
    befehle.zeigeParameter();
    befehle.bearbeiteNaechstenBefehl();
    befehle.zeigeParameter();
    befehle.bearbeiteNaechstenBefehl();
    befehle.zeigeParameter();
}
